#
# Utility variables and functions for make invokation
#

: ${PARALLEL_MAKE:=$(expr 1 + 2 \* $CORE_COUNT)}
: ${dest_dir:="DESTDIR"}
: ${sequential_build:=false}

do_make() {
	if [ ! -r Makefile ]; then
		echo "Nothing to do for compiling $recipe_name"
		return 0
	fi
	if $sequential_build; then
		log_exec make $make_other_flags "$@"
	else
		log_exec make -j$PARALLEL_MAKE $make_other_flags "$@"
	fi
}

do_make_install() {
	if [ ! -r Makefile ]; then
		echo "No rule for installing $recipe_name"
		exit 1
	fi
	log_exec rm -rf $install_loc/* $install_loc/.fakeroot
	log_exec mkdir -p $install_loc
	log_exec make install $dest_dir=$install_loc $make_other_flags $make_install_other_flags "$@"
}
	