#
# This script is automatically sourced by utils.sh at the beginning of each build-step script;
# it provides access to the native sysroot provided commands
#

# Include NATIVE_SYSROOT_LOC subdirectories in front of path, in the proper order
prepend_subdirs_to_path() {
	local prefix="$1"
	shift
	local subdir dir pathadd cleanedpath=":${PATH}:"
	for subdir in "$@"; do
		dir=${prefix%/}/${subdir#/}
		cleanedpath=${cleanedpath/:$dir:/:}
		if [ -d "$dir" ]; then
			pathadd="$pathadd:$dir"
		fi
	done
	PATH="${pathadd}${cleanedpath%:}"
}

prepend_dirs_to_path() {
	prepend_subdirs_to_path "/" "$@"
}

prepend_local_subdirs_to_path() {
	prepend_subdirs_to_path $(pwd) "$@"
}

prepend_sysroot_subdirs_to_path() {
	prepend_subdirs_to_path $NATIVE_SYSROOT_LOC "$@"
}

prepend_sysroot_subdirs_to_path /usr/local/bin /bin /usr/bin /usr/local/sbin /sbin /usr/sbin
