######################################################################################################################
#                                                                                                                    #
#                                                     Task utilities                                                 #
#                                                                                                                    #
######################################################################################################################
: ${recipe_statedir:=.ac6_build}

recipe_task_state_file() {
	local task="$1"
	local recipe="$2"
	[ -n "$task" ] || task="$current_task"
	[ -n "$recipe" ] || recipe="$recipe_name"
	task="${task,,}"
	task="${task/ /-}"
	local recipe_dir="."
	local recipe_spec
	if [ "$recipe" != "$recipe_name" ]; then
		local dir
		for dir in ../$recipe*; do
			if [ -d $dir ]; then
				recipe_dir=dir
				recipe_spec=${dir##*/}
				break
			fi
		done
	else
		recipe_spec=${recipe_id}
	fi
	if [ -z "$recipe_spec" ]; then
		recipe_spec=${recipe}
	fi
	case $task in
		populate-sysroot)
			echo "${SYSROOT_LOC}/${recipe_statedir}/task.${task}.${recipe_spec}"
			;;
		split | package)
			echo "${PLATFORM_LOC}/feeds/${recipe_statedir}/task.${task}.${recipe_spec}"
			;;
		*)
			echo "${recipe_dir}/${recipe_statedir}/task.${task}.${recipe_spec}"
			;;
	esac
}

poison_recipe_task() {
	local task_state_file=$(recipe_task_state_file "$@")
	# Only poison a task that was already executed...
	if [ -s "$task_state_file" ]; then
		task_execute_date > $task_state_file.poison
	fi
}

unconditional_task() {
	local task_state_file=$(recipe_task_state_file)
	# Poison myself even if I was not yet executed...
	task_execute_date > $task_state_file.poison
}

first_executable() {
	local exe file
	for exe; do
		file="$(which $exe)"
		if [ -n "$file" -a -x "$file" ]; then
			echo "$exe"
			break
		fi
	done
}

launch_terminal() {
	local term=$(first_executable $possible_terminals)
	$term
}
